package route

import (
	"net/http"

	"amuz.es/gogs/infra/api_skeleton/subsys/http/iface"
	"amuz.es/gogs/infra/api_skeleton/util"
	common_iface "amuz.es/gogs/infra/api_skeleton/util/iface"
	"github.com/gin-gonic/gin"
	"amuz.es/gogs/infra/api_skeleton/subsys/db"
	"time"
	"amuz.es/gogs/infra/api_skeleton/enums"
)

func Index(c *gin.Context) {
	uuidTest,_ :=common_iface.NewUUIDV4()
	resp := &iface.WrappedResponse{
		Message: "Pong!",
		Content: []iface.KeyValuePair{
			{
				Key:   "name",
				Value: util.Config.Name(),
			},
			{
				Key:   "version",
				Value: util.Config.Version(),
			},
			{
				Key:   "buildDate",
				Value: util.Config.BuildDate(),
			},
			{
				Key:   "phase",
				Value: util.Config.Phase,
			},
			{
				Key:"uuid",
				Value: uuidTest,
			},
			{
				Key: "model",
				Value: db.NewMember(
					uint64(0),
					time.Now(),
					nil,
					"hello",
					"name",
					"hello",
					enums.MemberStatusEnabled,
					uint64(0),
				),
			},
		},
	}
	util.DumpJSON(c, http.StatusOK, resp)
}
