package route

import (
	"net/http"
	"time"

	"amuz.es/gogs/infra/api_skeleton/util"
)

var logger = util.NewLogger("route")

func extractLastModified(hh http.Header) (modified *time.Time) {
	if modifiedStr := extractHeader("If-Modified-Since", hh); modifiedStr == nil {
	} else if modifiedTime, err := http.ParseTime(*modifiedStr); err != nil {
	} else {
		modified = &modifiedTime
	}
	return
}

func extractHeader(key string, hh http.Header) (ret *string) {
	if hdrStr := hh.Get(key); hdrStr == "" {
	} else {
		ret = &hdrStr
	}
	return
}
