package iface

import (
	"amuz.es/gogs/infra/api_skeleton/util"
	"github.com/google/uuid"
)

const Bytes16Length = 16
const Bytes32Length = 32
const Bytes64Length = 64
const UUIDLength = 16

type Bytes16 [Bytes16Length]byte
type Bytes32 [Bytes32Length]byte
type Bytes64 [Bytes64Length]byte
type UUID struct {
	uuid.UUID
}

var logger = util.NewLogger("common_iface")

type Serializable interface {
	Marshal() ([]byte, error)
	Unmarshal(buf []byte) error
	String() string
}



type JSONSerializable interface {
	UnmarshalJSON(b []byte) error
	MarshalJSON() ([]byte, error)
}